import java.util.*;

public class LessThan extends BinaryConstraint {

    public LessThan(Problem pb,IntVar x,IntVar y){
	super(pb,x,y);
	name = "LessThan";
    }

    public LessThan(Problem pb,IntVar x,int y){
	super(pb,x,new IntVar("anon",y,y,pb));
	name = "LessThan";
    }

    void propagateInit(){
	if (pb.trace) System.out.println("propagate() "+ this);
	y.removeBelow(x.min()+1);
	x.removeAbove(y.max()-1);
    }
    
    void propagateRemoval(IntVar v, int value){}
    
    void propagateUPB(IntVar v){propagate(v);}
    
    void propagateLWB(IntVar v){propagate(v);}
    
    void propagateInstantiate(IntVar v){propagate(v);}

    boolean isLegal(){
	return x.max() < y.max() && x.min() < y.min();
    }

    void propagate(IntVar v){
	if (x.equals(v)) y.removeBelow(x.min()+1);
	if (y.equals(v)) x.removeAbove(y.max()-1);
    }
}
