import java.util.*;

public class NotEquals extends BinaryConstraint {

    public NotEquals(Problem pb,IntVar x, IntVar y){
	super(pb,x,y);
	name = "NotEquals";
    }

    void propagateInit(){
	if (x.isInstantiated()) y.remove(x.getValue());
	if (y.isInstantiated()) x.remove(y.getValue());
    }

    void propagateRemoval(IntVar v, int value){}
    
    void propagateUPB(IntVar v){}
    
    void propagateLWB(IntVar v){}
    
    void propagateInstantiate(IntVar v){
	if (v.equals(x)) y.remove(x.getValue());
	if (v.equals(y)) x.remove(y.getValue());
    }

    boolean isLegal(){
	return (x.isInstantiated() && y.isInstantiated() && x.getValue() != y.getValue()) ||
	       (x.isInstantiated() && !y.contains(x.getValue())) ||
	       (y.isInstantiated() && !x.contains(y.getValue())) ||
	       (x.size() > 1 && y.size() > 1);
    }
    
}
