import java.util.*;

public class ReversibleBool extends ReversibleVar {

    Problem pb;
    int value;
    Stack<Integer> whenChanged;
    Stack<Integer> priorValue;

    public ReversibleBool(Problem pb,boolean initialValue){
	this.pb     = pb;
	whenChanged = new Stack<Integer>();
	priorValue  = new Stack<Integer>();
	value       = (initialValue) ? 1 : 0;
	whenChanged.push(pb.world);
    }

    boolean getValue(){return value == 1;}

    void setValue(boolean b){
	int x = (b) ? 1 : 0;       
	if (value != x && whenChanged.peek() != pb.world){
	    pb.trail.peek().add(this);
	    whenChanged.push(pb.world);
	    priorValue.push(value);
	}
	value = x;
    }

    void restoreValue(){
	whenChanged.pop();
	value = priorValue.pop();
    }
    
    void setTrue(){setValue(true);}

    void setFalse(){setValue(false);}

    boolean isTrue(){return value == 1;};

    boolean isFalse(){return value == 0;};
}
