import java.util.*;

public class ReversibleInt extends ReversibleVar {

    Problem pb;
    int value;
    Stack<Integer> whenChanged;
    Stack<Integer> priorValue;
    

    public ReversibleInt(Problem pb,int initialValue){
	this.pb     = pb;
	whenChanged = new Stack<Integer>();
	priorValue  = new Stack<Integer>();
	value       = initialValue;
	whenChanged.push(pb.world);
    }

    int getValue(){return value;}

    void setValue(int x){
	if (value != x && whenChanged.peek() != pb.world){
	    pb.trail.peek().add(this);
	    whenChanged.push(pb.world);
	    priorValue.push(value);
	}
	value = x;
    }
    
    void restoreValue(){
	whenChanged.pop();
	value = priorValue.pop();
    }
}
