package weeSeepy.constraints;

import java.util.*;
import weeSeepy.problem.*;
import weeSeepy.variables.*;

public abstract class BinaryConstraint extends Constraint {

    IntVar x,y;

    public BinaryConstraint(Problem pb,IntVar x, IntVar y){
	super(pb);
	this.x = x;
	this.y = y;
	addVariable(x);
	addVariable(y);
	assert x != null && y != null : "variables must not be null";
    }

    public String toString(){
	String s = name +" "+ x +" "+ y;
	if (onQueue) s = s +" on Queue";
	if (!onQueue) s = s +" not on Queue";
	if (init) s = s +" init";
	return s;
    }
}
