package weeSeepy.constraints;

import weeSeepy.problem.*;
import weeSeepy.variables.*;

public class NotEquals extends BinaryConstraint {

    public NotEquals(Problem pb,IntVar x, IntVar y){
	super(pb,x,y);
	name = "NotEquals";
	assert !x.equals(y) : "x and y must be different "+ this;
    }

    public void propagate(){
	if (x.isInstantiated()) y.remove(x.getValue());
	if (y.isInstantiated()) x.remove(y.getValue());
    }

    public void propagateInit(){
	propagate();
    }

    public void propagateRemoval(IntVar v, int value){}
    
    public void propagateUPB(IntVar v){}
    
    public void propagateLWB(IntVar v){}
    
    public void propagateInstantiate(IntVar v){
	propagate();
    }

    public boolean isEntailed(){
	return x.max() < y.min() || x.min() > y.max();
    }

    public Constraint makeOpposite(){
	return null;
    }
    //
    // x = y
    //
    
    public boolean isLegal(){
	return (x.isInstantiated() && y.isInstantiated() && x.getValue() != y.getValue()) ||
	       (x.isInstantiated() && !y.contains(x.getValue())) ||
	       (y.isInstantiated() && !x.contains(y.getValue())) ||
	       (x.size() > 1 && y.size() > 1);
    }    
}
