package weeSeepy.constraints;

import weeSeepy.problem.*;
import weeSeepy.variables.*;

public class Or extends Constraint {

    public Or(Problem pb,Constraint C1,Constraint C2){
	super(pb);//,null,null);
	C1.reify();
	C2.reify();
	name = "Or";
	pb.post(C1);
	pb.post(C2);
	pb.post(new SumGEQ(pb,new int[]{1,1},new IntVar[]{C1.b,C2.b},1));
    }

    public Or(Problem pb,Constraint[] C){
	super(pb);//,null,null);
	int n = C.length;
	int[] a = new int[n];
	IntVar[] b = new IntVar[n];
	for (int i=0;i<n;i++){
	    C[i].reify();
	    pb.post(C[i]);
	    a[i] = 1;
	    b[i] = C[i].b;
	}
	name = "Or";
	pb.post(new SumGEQ(pb,a,b,1));
    }
    
    public void propagateInit(){
	propagate();
    }

    public void propagate(){}
    
    public void propagateRemoval(IntVar v, int value){}
    
    public void propagateUPB(IntVar v){}
    
    public void propagateLWB(IntVar v){}
    
    public void propagateInstantiate(IntVar v){}

    public boolean isEntailed(){
	return false;
    }

     public Constraint makeOpposite(){
	 return null;
    }

    public boolean isLegal(){
	return true;
    }
}
