package weeSeepy.gcol;

import org.chocosolver.solver.Model;
import org.chocosolver.solver.Solver;
import org.chocosolver.solver.variables.IntVar;
import org.chocosolver.solver.exception.ContradictionException;
import java.util.*;
import java.io.*;

public class ChocoGCol {

    public static void main(String args[]) throws ContradictionException, IOException{

	String s = "";
	Scanner sc = new Scanner(new File(args[0]));
	while (sc.hasNext() && !s.equals("p")) s = sc.next();
	sc.next();
	int n = sc.nextInt();   
	int m = sc.nextInt(); 
	int[][] A = new int[n][n];
	while (sc.hasNext()){
	    s     = sc.next(); // skip "edge"
	    int i = sc.nextInt() - 1;
	    int j = sc.nextInt() - 1; 
	    A[i][j] = A[j][i] = 1;
	}
	sc.close();
	
	Model model   = new Model("ChocoTest");
	Solver solver = model.getSolver();

	int k = Integer.parseInt(args[1]);

	IntVar[] v = model.intVarArray("v",n,1,k);

	for (int i=0;i<n-1;i++)
	    for (int j=i+1;j<n;j++)
		if (A[i][j] == 1) model.arithm(v[i],"!=",v[j]).post();

	System.out.println(solver.solve());
    }
}
