package weeSeepy.gcol;

import weeSeepy.problem.*;
import weeSeepy.variables.*;
import weeSeepy.constraints.*;
import java.util.*;
import java.io.*;

public class GColEnum {

    public static void main(String[] args) throws IOException {
	
	String s = "";
	Scanner sc = new Scanner(new File(args[0]));
	while (sc.hasNext() && !s.equals("p")) s = sc.next();
	sc.next();
	int n = sc.nextInt();   
	int m = sc.nextInt(); 
	int[][] A = new int[n][n];
	while (sc.hasNext()){
	    s     = sc.next(); // skip "edge"
	    int i = sc.nextInt() - 1;
	    int j = sc.nextInt() - 1; 
	    A[i][j] = A[j][i] = 1;
	}
	sc.close();
	 
	Problem pb = new Problem("Col");
	
	int k = Integer.parseInt(args[1]);

	IntVar[] v = new IntVar[n];

	for (int i=0;i<n;i++) v[i] = pb.intVar("v_" + i,1,k);

	for (int i=0;i<n-1;i++)
	    for (int j=i+1;j<n;j++)
		if (A[i][j] == 1) pb.post(new NotEquals(pb,v[i],v[j]));
	
	while (pb.nextSolution()){
	    for (int i=0;i<n;i++) System.out.print(v[i].getValue() +" ");
	    System.out.println();
	}
    }
	
}
