package weeSeepy.reversibles;

import java.util.*;
import weeSeepy.problem.*;

public class ReversibleBool extends ReversibleVar {

    public ReversibleBool(Problem pb,boolean initialValue){
	this.pb     = pb;
	whenChanged = new Stack<Integer>();
	priorValue  = new Stack<Integer>();
	value       = (initialValue) ? 1 : 0;
	whenChanged.push(pb.world);
    }

    public boolean getValue(){return value == 1;}

    public void setValue(boolean b){
	int x = (b) ? 1 : 0;       
	if (value != x && whenChanged.peek() != pb.world){
	    pb.trail.peek().add(this);
	    whenChanged.push(pb.world);
	    priorValue.push(value);
	}
	value = x;
    }
    
    public void setTrue(){setValue(true);}

    public void setFalse(){setValue(false);}

    public boolean isTrue(){return value == 1;};

    public boolean isFalse(){return value == 0;};
}
