package weeSeepy.reversibles;

import java.util.*;
import weeSeepy.problem.*;

public class ReversibleInt extends ReversibleVar {    

    public ReversibleInt(Problem pb,int initialValue){
	this.pb     = pb;
	whenChanged = new Stack<Integer>();
	priorValue  = new Stack<Integer>();
	value       = initialValue;
	whenChanged.push(pb.world);
    }

    public int getValue(){return value;}

    public void setValue(int x){
	if (value != x && whenChanged.peek() != pb.world){
	    pb.trail.peek().add(this);
	    whenChanged.push(pb.world);
	    priorValue.push(value);
	}
	value = x;
    }
}
