package weeSeepy.squares;

import weeSeepy.problem.*;
import weeSeepy.variables.*;
import weeSeepy.constraints.*;
import java.util.*;
import java.io.*;

public class Test {

    public static void main(String[] args) throws IOException {
	
	String s = "";
	Scanner sc = new Scanner(new File(args[0]));
	sc.next(); // pallet
	int maxX = sc.nextInt();
	int maxY = sc.nextInt();
	sc.next(); // n
	int n = sc.nextInt();
	int[] size = new int[n];
	for (int i=0;i<n;i++) size[i] = sc.nextInt();
	sc.close();
	 
	Problem pb = new Problem("Squares");

	IntVar[] x = new IntVar[n];
	IntVar[] y = new IntVar[n];

	for (int i=0;i<n;i++){
	    x[i] = pb.intVar("x_" + i,0,maxX-size[i]);
	    y[i] = pb.intVar("y_" + i,0,maxY-size[i]);
	}
	
	pb.post(new GreaterThanOrEqual(pb,x[0],x[1],size[1])); // square[0] right of square[1]
	pb.post(new GreaterThanOrEqual(pb,y[1],y[0],size[0])); // square[1] above square[0]
		
	pb.trace = true;
	System.out.println(pb.solve());
	System.out.println("nodes: "+ pb.nodes +"  fails: "+ pb.fails);
	for (int i=0;i<n;i++) System.out.println(x[i] +" "+ y[i] +" size: "+ size[i]);
	System.out.println();
        //pb.show();
    }
	
}
