package weeSeepy.test;

import org.chocosolver.solver.Model;
import org.chocosolver.solver.Solver;
import org.chocosolver.solver.variables.IntVar;
import org.chocosolver.solver.constraints.Constraint;
import org.chocosolver.solver.exception.ContradictionException;

public class ChocoTestMax {

    public static void main(String[] args) throws ContradictionException {

	Model model   = new Model("ChocoTestMax");
	Solver solver = model.getSolver();

	int n = 3;
	
	IntVar x = model.intVar("x",0,2);
	IntVar[] v = new IntVar[n];

	for (int i=0;i<n;i++) v[i] = model.intVar("v_"+ i,0,3);

	
	model.max(x,v).post();

	System.out.println(x +" "+ v[0] +" "+ v[1] +" "+ v[2]);
	System.out.println("*********************");
	
	solver.propagate();
	System.out.println(x +" "+ v[0] +" "+ v[1] +" "+ v[2]);
	System.out.println("*********************");

	v[1].instantiateTo(1,null);
	solver.propagate();
	System.out.println(x +" "+ v[0] +" "+ v[1] +" "+ v[2]);
	System.out.println("*********************");
	
	x.instantiateTo(1,null);
	solver.propagate();
	System.out.println(x +" "+ v[0] +" "+ v[1] +" "+ v[2]);
	System.out.println("*********************");

	v[0].removeValue(1,null);
	solver.propagate();
	System.out.println(x +" "+ v[0] +" "+ v[1] +" "+ v[2]);
	System.out.println("*********************");
    }
}
