package weeSeepy.test;

import org.chocosolver.solver.Model;
import org.chocosolver.solver.Solver;
import org.chocosolver.solver.variables.IntVar;
import org.chocosolver.solver.constraints.Constraint;
import org.chocosolver.solver.exception.ContradictionException;

public class ChocoTestMaxJames {

    public static void main(String[] args) throws ContradictionException {

	Model model   = new Model("ChocoTestMaxJames");
	Solver solver = model.getSolver();
	
	IntVar x  = model.intVar("x",1,5);
	IntVar v1 = model.intVar("v1",1,3);
	IntVar v2 = model.intVar("v2",1,5);

	
	model.max(x,new IntVar[]{v1,v2}).post();

	System.out.println(x +" "+ v1 +" "+ v2);
	System.out.println("*********************");
	
	solver.propagate();
	System.out.println(x +" "+ v1 +" "+ v2);
	System.out.println("*********************");
	
	x.removeValue(4,null);
	solver.propagate();
	System.out.println(x +" "+ v1 +" "+ v2);
	System.out.println("*********************");
	
	System.out.println(v2.contains(4));
	System.out.println("*********************");
    }
}
