package weeSeepy.test;

import org.chocosolver.solver.Model;
import org.chocosolver.solver.Solver;
import org.chocosolver.solver.variables.IntVar;
import org.chocosolver.solver.constraints.Constraint;
import org.chocosolver.solver.exception.ContradictionException;

public class ChocoTestOr {

    public static void main(String[] args) throws ContradictionException {

	Model model   = new Model("ChocoTestOr");
	Solver solver = model.getSolver();

	IntVar x = model.intVar("x",0,9);	

	Constraint c1 = model.arithm(x,"<",3);
	Constraint c2 = model.arithm(x,">",4);
	
	model.or(c1,c2).post();

	System.out.println("initial value: "+ x);

	solver.propagate();

	System.out.println("post propagation: "+ x);
	
	x.updateLowerBound(3,null); //removeBelow(3);

	System.out.println("removed below 3: "+ x);

	solver.propagate();

	System.out.println("post propagation: "+ x);
    }
}
