//
// The same as TestMax but the max constraint is decomposed to
//
//       x = v[0] or x = v[1] x = v[2]
//       x >= v[0] and x >= v[1] and x >= v[2]
//

package weeSeepy.test;

import weeSeepy.problem.*;
import weeSeepy.variables.*;
import weeSeepy.constraints.*;

public class TestMaxOr {

    public static void main(String[] args){
	Problem pb = new Problem("TestMaxOr");

	int n = 3;
	
	IntVar x = pb.intVar("x",0,2);
	IntVar[] v = new IntVar[n];

	for (int i=0;i<n;i++) v[i] = pb.intVar("v_"+ i,0,3);

	Constraint[] c = new Constraint[n];
	for (int i=0;i<n;i++)
	    c[i] = new Equals(pb,x,v[i]);
	new Or(pb,c);

	for (int i=0;i<n;i++)
	    pb.post(new GreaterThanOrEqual(pb,x,v[i]));
	
	pb.show();
	System.out.println("*********************");
	
	System.out.println(pb.propagate());
	pb.show();
	System.out.println("*********************");

	v[1].instantiate(1);
	System.out.println(pb.propagate());
	pb.show();
	System.out.println("*********************");
	
	x.instantiate(1);
	System.out.println(pb.propagate());
	pb.show();
	System.out.println("*********************");

	v[0].remove(1);
	System.out.println(pb.propagate());
	pb.show();
	System.out.println("*********************");
    }
}
